#include "mbed.h"
#include "SLCD.h"


#define PROGNAME "lightsense_kl46z_PWM v1\n\r"
#define DATATIME 400 // milliseconds
#define LCDLEN 10
#define LIGHTSENSORPORT PTE22

SLCD slcd; //define LCD display globally define
Serial pc(USBTX, USBRX);
Timer LEDTimer;

void LCDMess(char *lMess){
        slcd.Home();
        slcd.clear();
        slcd.printf(lMess);
        
        slcd.DP(0, false);  //Disables the decimal point in position 0
} 

int main() {
    PwmOut greenColor(LED_GREEN);
    PwmOut redColor(LED_RED);
    AnalogIn LightSensor(LIGHTSENSORPORT);
    float lightData; 
    char lcdData[LCDLEN];
   
    int timeToChangeDF = DATATIME;
    // set up timer for next step of Duty Factor timing
    LEDTimer.start();
    LEDTimer.reset();
    pc.printf(PROGNAME);
    
    
    while(true) {    
        if (LEDTimer.read_ms() > timeToChangeDF){ // check for timer time out transtion
            lightData = (1.0 - LightSensor.read()) * 100; // show as increasiing with increasing intensity
            greenColor.write(1.0 - lightData);
            redColor.write(1.0 - lightData);
            sprintf(lcdData,"%4.3f",lightData);
            LCDMess(lcdData);  
            pc.printf("%4.3f\r\n",lightData);
            timeToChangeDF = DATATIME;
            LEDTimer.reset();
        }        
    }// end while
}
